import{s as Qt,n as wt,o as Pt}from"../chunks/scheduler.6062bdaf.js";import{S as Ct,i as Nt,g as r,s as a,r as c,A as Dt,h as s,f as o,c as i,j as f,u,x as U,k as x,y as e,a as b,v as l,d as p,t as g,w as _}from"../chunks/index.4bca734e.js";import{D as k}from"../chunks/Docstring.81ba5e3c.js";import{H as Rt,E as Ft}from"../chunks/EditOnGithub.74ab2baa.js";function Lt(bt){let h,j,G,S,q,K,R,B,n,Q,rt,E,zt="Handles the ONNX Runtime quantization process for models shared on huggingface.co/models.",st,z,w,mt,H,vt="Computes the quantization ranges.",dt,v,P,ct,M,Tt="Performs the calibration step and computes the quantization ranges.",ut,T,C,lt,I,$t="Instantiates a <code>ORTQuantizer</code> from an ONNX model file or an <code>ORTModel</code>.",pt,$,N,gt,W,Ot="Creates the calibration <code>datasets.Dataset</code> to use for the post-training static quantization calibration step.",_t,O,D,ht,V,yt="Performs the calibration step and collects the quantization ranges without computing them.",ft,y,F,xt,A,qt="Quantizes a model given the optimization specifications defined in <code>quantization_config</code>.",J,L,Y,X,Z;return q=new Rt({props:{title:"Quantization",local:"quantization",headingTag:"h1"}}),R=new Rt({props:{title:"ORTQuantizer",local:"optimum.onnxruntime.ORTQuantizer",headingTag:"h2"}}),Q=new k({props:{name:"class optimum.onnxruntime.ORTQuantizer",anchor:"optimum.onnxruntime.ORTQuantizer",parameters:[{name:"onnx_model_path",val:": Path"},{name:"config",val:": typing.Optional[ForwardRef('PretrainedConfig')] = None"}],source:"https://github.com/huggingface/optimum/blob/v1.23.3/optimum/onnxruntime/quantization.py#L84"}}),w=new k({props:{name:"compute_ranges",anchor:"optimum.onnxruntime.ORTQuantizer.compute_ranges",parameters:[],source:"https://github.com/huggingface/optimum/blob/v1.23.3/optimum/onnxruntime/quantization.py#L262",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The dictionary mapping the nodes name to their quantization ranges.</p>
`}}),P=new k({props:{name:"fit",anchor:"optimum.onnxruntime.ORTQuantizer.fit",parameters:[{name:"dataset",val:": Dataset"},{name:"calibration_config",val:": CalibrationConfig"},{name:"onnx_augmented_model_name",val:": typing.Union[str, pathlib.Path] = 'augmented_model.onnx'"},{name:"operators_to_quantize",val:": typing.Optional[typing.List[str]] = None"},{name:"batch_size",val:": int = 1"},{name:"use_external_data_format",val:": bool = False"},{name:"use_gpu",val:": bool = False"},{name:"force_symmetric_range",val:": bool = False"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTQuantizer.fit.dataset",description:`<strong>dataset</strong> (<code>Dataset</code>) &#x2014;
The dataset to use when performing the calibration step.`,name:"dataset"},{anchor:"optimum.onnxruntime.ORTQuantizer.fit.calibration_config",description:`<strong>calibration_config</strong> (<code>~CalibrationConfig</code>) &#x2014;
The configuration containing the parameters related to the calibration step.`,name:"calibration_config"},{anchor:"optimum.onnxruntime.ORTQuantizer.fit.onnx_augmented_model_name",description:`<strong>onnx_augmented_model_name</strong> (<code>Union[str, Path]</code>, defaults to <code>&quot;augmented_model.onnx&quot;</code>) &#x2014;
The path used to save the augmented model used to collect the quantization ranges.`,name:"onnx_augmented_model_name"},{anchor:"optimum.onnxruntime.ORTQuantizer.fit.operators_to_quantize",description:`<strong>operators_to_quantize</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
List of the operators types to quantize.`,name:"operators_to_quantize"},{anchor:"optimum.onnxruntime.ORTQuantizer.fit.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, defaults to 1) &#x2014;
The batch size to use when collecting the quantization ranges values.`,name:"batch_size"},{anchor:"optimum.onnxruntime.ORTQuantizer.fit.use_external_data_format",description:`<strong>use_external_data_format</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use external data format to store model which size is &gt;= 2Gb.`,name:"use_external_data_format"},{anchor:"optimum.onnxruntime.ORTQuantizer.fit.use_gpu",description:`<strong>use_gpu</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the GPU when collecting the quantization ranges values.`,name:"use_gpu"},{anchor:"optimum.onnxruntime.ORTQuantizer.fit.force_symmetric_range",description:`<strong>force_symmetric_range</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to make the quantization ranges symmetric.`,name:"force_symmetric_range"}],source:"https://github.com/huggingface/optimum/blob/v1.23.3/optimum/onnxruntime/quantization.py#L158",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The dictionary mapping the nodes name to their quantization ranges.</p>
`}}),C=new k({props:{name:"from_pretrained",anchor:"optimum.onnxruntime.ORTQuantizer.from_pretrained",parameters:[{name:"model_or_path",val:": typing.Union[ForwardRef('ORTModel'), str, pathlib.Path]"},{name:"file_name",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTQuantizer.from_pretrained.model_or_path",description:`<strong>model_or_path</strong> (<code>Union[ORTModel, str, Path]</code>) &#x2014;
Can be either:<ul>
<li>A path to a saved exported ONNX Intermediate Representation (IR) model, e.g., \`./my_model_directory/.</li>
<li>Or an <code>ORTModelForXX</code> class, e.g., <code>ORTModelForQuestionAnswering</code>.</li>
</ul>`,name:"model_or_path"},{anchor:"optimum.onnxruntime.ORTQuantizer.from_pretrained.file_name(Optional[str],",description:`<strong>file_name(<code>Optional[str]</code>,</strong> defaults to <code>None</code>) &#x2014;
Overwrites the default model file name from <code>&quot;model.onnx&quot;</code> to <code>file_name</code>.
This allows you to load different model files from the same repository or directory.`,name:"file_name(Optional[str],"}],source:"https://github.com/huggingface/optimum/blob/v1.23.3/optimum/onnxruntime/quantization.py#L111",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>An instance of <code>ORTQuantizer</code>.</p>
`}}),N=new k({props:{name:"get_calibration_dataset",anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset",parameters:[{name:"dataset_name",val:": str"},{name:"num_samples",val:": int = 100"},{name:"dataset_config_name",val:": typing.Optional[str] = None"},{name:"dataset_split",val:": typing.Optional[str] = None"},{name:"preprocess_function",val:": typing.Optional[typing.Callable] = None"},{name:"preprocess_batch",val:": bool = True"},{name:"seed",val:": int = 2016"},{name:"use_auth_token",val:": typing.Union[bool, str, NoneType] = None"},{name:"token",val:": typing.Union[bool, str, NoneType] = None"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.dataset_name",description:`<strong>dataset_name</strong> (<code>str</code>) &#x2014;
The dataset repository name on the Hugging Face Hub or path to a local directory containing data files
to load to use for the calibration step.`,name:"dataset_name"},{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.num_samples",description:`<strong>num_samples</strong> (<code>int</code>, defaults to 100) &#x2014;
The maximum number of samples composing the calibration dataset.`,name:"num_samples"},{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.dataset_config_name",description:`<strong>dataset_config_name</strong> (<code>Optional[str]</code>, defaults to <code>None</code>) &#x2014;
The name of the dataset configuration.`,name:"dataset_config_name"},{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.dataset_split",description:`<strong>dataset_split</strong> (<code>Optional[str]</code>, defaults to <code>None</code>) &#x2014;
Which split of the dataset to use to perform the calibration step.`,name:"dataset_split"},{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.preprocess_function",description:`<strong>preprocess_function</strong> (<code>Optional[Callable]</code>, defaults to <code>None</code>) &#x2014;
Processing function to apply to each example after loading dataset.`,name:"preprocess_function"},{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.preprocess_batch",description:`<strong>preprocess_batch</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether the <code>preprocess_function</code> should be batched.`,name:"preprocess_batch"},{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.seed",description:`<strong>seed</strong> (<code>int</code>, defaults to 2016) &#x2014;
The random seed to use when shuffling the calibration dataset.`,name:"seed"},{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.use_auth_token",description:`<strong>use_auth_token</strong> (<code>Optional[Union[bool,str]]</code>, defaults to <code>None</code>) &#x2014;
Deprecated. Please use the <code>token</code> argument instead.`,name:"use_auth_token"},{anchor:"optimum.onnxruntime.ORTQuantizer.get_calibration_dataset.token",description:`<strong>token</strong> (<code>Optional[Union[bool,str]]</code>, defaults to <code>None</code>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>huggingface-cli login</code> (stored in <code>huggingface_hub.constants.HF_TOKEN_PATH</code>).`,name:"token"}],source:"https://github.com/huggingface/optimum/blob/v1.23.3/optimum/onnxruntime/quantization.py#L419",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The calibration <code>datasets.Dataset</code> to use for the post-training static quantization calibration
step.</p>
`}}),D=new k({props:{name:"partial_fit",anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit",parameters:[{name:"dataset",val:": Dataset"},{name:"calibration_config",val:": CalibrationConfig"},{name:"onnx_augmented_model_name",val:": typing.Union[str, pathlib.Path] = 'augmented_model.onnx'"},{name:"operators_to_quantize",val:": typing.Optional[typing.List[str]] = None"},{name:"batch_size",val:": int = 1"},{name:"use_external_data_format",val:": bool = False"},{name:"use_gpu",val:": bool = False"},{name:"force_symmetric_range",val:": bool = False"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.dataset",description:`<strong>dataset</strong> (<code>Dataset</code>) &#x2014;
The dataset to use when performing the calibration step.`,name:"dataset"},{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.calibration_config",description:`<strong>calibration_config</strong> (<code>CalibrationConfig</code>) &#x2014;
The configuration containing the parameters related to the calibration step.`,name:"calibration_config"},{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.onnx_augmented_model_name",description:`<strong>onnx_augmented_model_name</strong> (<code>Union[str, Path]</code>, defaults to <code>&quot;augmented_model.onnx&quot;</code>) &#x2014;
The path used to save the augmented model used to collect the quantization ranges.`,name:"onnx_augmented_model_name"},{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.operators_to_quantize",description:`<strong>operators_to_quantize</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
List of the operators types to quantize.`,name:"operators_to_quantize"},{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, defaults to 1) &#x2014;
The batch size to use when collecting the quantization ranges values.`,name:"batch_size"},{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.use_external_data_format",description:`<strong>use_external_data_format</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether uto se external data format to store model which size is &gt;= 2Gb.`,name:"use_external_data_format"},{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.use_gpu",description:`<strong>use_gpu</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use the GPU when collecting the quantization ranges values.`,name:"use_gpu"},{anchor:"optimum.onnxruntime.ORTQuantizer.partial_fit.force_symmetric_range",description:`<strong>force_symmetric_range</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to make the quantization ranges symmetric.`,name:"force_symmetric_range"}],source:"https://github.com/huggingface/optimum/blob/v1.23.3/optimum/onnxruntime/quantization.py#L212"}}),F=new k({props:{name:"quantize",anchor:"optimum.onnxruntime.ORTQuantizer.quantize",parameters:[{name:"quantization_config",val:": QuantizationConfig"},{name:"save_dir",val:": typing.Union[str, pathlib.Path]"},{name:"file_suffix",val:": typing.Optional[str] = 'quantized'"},{name:"calibration_tensors_range",val:": typing.Union[typing.Dict[str, typing.Tuple[float, float]], NoneType] = None"},{name:"use_external_data_format",val:": bool = False"},{name:"preprocessor",val:": typing.Optional[optimum.onnxruntime.preprocessors.quantization.QuantizationPreprocessor] = None"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTQuantizer.quantize.quantization_config",description:`<strong>quantization_config</strong> (<code>QuantizationConfig</code>) &#x2014;
The configuration containing the parameters related to quantization.`,name:"quantization_config"},{anchor:"optimum.onnxruntime.ORTQuantizer.quantize.save_dir",description:`<strong>save_dir</strong> (<code>Union[str, Path]</code>) &#x2014;
The directory where the quantized model should be saved.`,name:"save_dir"},{anchor:"optimum.onnxruntime.ORTQuantizer.quantize.file_suffix",description:`<strong>file_suffix</strong> (<code>Optional[str]</code>, defaults to <code>&quot;quantized&quot;</code>) &#x2014;
The file_suffix used to save the quantized model.`,name:"file_suffix"},{anchor:"optimum.onnxruntime.ORTQuantizer.quantize.calibration_tensors_range",description:`<strong>calibration_tensors_range</strong> (<code>Optional[Dict[str, Tuple[float, float]]]</code>, defaults to <code>None</code>) &#x2014;
The dictionary mapping the nodes name to their quantization ranges, used and required only when applying static quantization.`,name:"calibration_tensors_range"},{anchor:"optimum.onnxruntime.ORTQuantizer.quantize.use_external_data_format",description:`<strong>use_external_data_format</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use external data format to store model which size is &gt;= 2Gb.`,name:"use_external_data_format"},{anchor:"optimum.onnxruntime.ORTQuantizer.quantize.preprocessor",description:`<strong>preprocessor</strong> (<code>Optional[QuantizationPreprocessor]</code>, defaults to <code>None</code>) &#x2014;
The preprocessor to use to collect the nodes to include or exclude from quantization.`,name:"preprocessor"}],source:"https://github.com/huggingface/optimum/blob/v1.23.3/optimum/onnxruntime/quantization.py#L281",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The path of the resulting quantized model.</p>
`}}),L=new Ft({props:{source:"https://github.com/huggingface/optimum/blob/main/docs/source/onnxruntime/package_reference/quantization.mdx"}}),{c(){h=r("meta"),j=a(),G=r("p"),S=a(),c(q.$$.fragment),K=a(),c(R.$$.fragment),B=a(),n=r("div"),c(Q.$$.fragment),rt=a(),E=r("p"),E.textContent=zt,st=a(),z=r("div"),c(w.$$.fragment),mt=a(),H=r("p"),H.textContent=vt,dt=a(),v=r("div"),c(P.$$.fragment),ct=a(),M=r("p"),M.textContent=Tt,ut=a(),T=r("div"),c(C.$$.fragment),lt=a(),I=r("p"),I.innerHTML=$t,pt=a(),$=r("div"),c(N.$$.fragment),gt=a(),W=r("p"),W.innerHTML=Ot,_t=a(),O=r("div"),c(D.$$.fragment),ht=a(),V=r("p"),V.textContent=yt,ft=a(),y=r("div"),c(F.$$.fragment),xt=a(),A=r("p"),A.innerHTML=qt,J=a(),c(L.$$.fragment),Y=a(),X=r("p"),this.h()},l(t){const d=Dt("svelte-u9bgzb",document.head);h=s(d,"META",{name:!0,content:!0}),d.forEach(o),j=i(t),G=s(t,"P",{}),f(G).forEach(o),S=i(t),u(q.$$.fragment,t),K=i(t),u(R.$$.fragment,t),B=i(t),n=s(t,"DIV",{class:!0});var m=f(n);u(Q.$$.fragment,m),rt=i(m),E=s(m,"P",{"data-svelte-h":!0}),U(E)!=="svelte-1tiz3jr"&&(E.textContent=zt),st=i(m),z=s(m,"DIV",{class:!0});var tt=f(z);u(w.$$.fragment,tt),mt=i(tt),H=s(tt,"P",{"data-svelte-h":!0}),U(H)!=="svelte-1183xvy"&&(H.textContent=vt),tt.forEach(o),dt=i(m),v=s(m,"DIV",{class:!0});var et=f(v);u(P.$$.fragment,et),ct=i(et),M=s(et,"P",{"data-svelte-h":!0}),U(M)!=="svelte-1tzjvze"&&(M.textContent=Tt),et.forEach(o),ut=i(m),T=s(m,"DIV",{class:!0});var nt=f(T);u(C.$$.fragment,nt),lt=i(nt),I=s(nt,"P",{"data-svelte-h":!0}),U(I)!=="svelte-p4e5on"&&(I.innerHTML=$t),nt.forEach(o),pt=i(m),$=s(m,"DIV",{class:!0});var ot=f($);u(N.$$.fragment,ot),gt=i(ot),W=s(ot,"P",{"data-svelte-h":!0}),U(W)!=="svelte-1xfi4es"&&(W.innerHTML=Ot),ot.forEach(o),_t=i(m),O=s(m,"DIV",{class:!0});var at=f(O);u(D.$$.fragment,at),ht=i(at),V=s(at,"P",{"data-svelte-h":!0}),U(V)!=="svelte-g6p4yh"&&(V.textContent=yt),at.forEach(o),ft=i(m),y=s(m,"DIV",{class:!0});var it=f(y);u(F.$$.fragment,it),xt=i(it),A=s(it,"P",{"data-svelte-h":!0}),U(A)!=="svelte-4dslow"&&(A.innerHTML=qt),it.forEach(o),m.forEach(o),J=i(t),u(L.$$.fragment,t),Y=i(t),X=s(t,"P",{}),f(X).forEach(o),this.h()},h(){x(h,"name","hf:doc:metadata"),x(h,"content",Ut),x(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(n,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,d){e(document.head,h),b(t,j,d),b(t,G,d),b(t,S,d),l(q,t,d),b(t,K,d),l(R,t,d),b(t,B,d),b(t,n,d),l(Q,n,null),e(n,rt),e(n,E),e(n,st),e(n,z),l(w,z,null),e(z,mt),e(z,H),e(n,dt),e(n,v),l(P,v,null),e(v,ct),e(v,M),e(n,ut),e(n,T),l(C,T,null),e(T,lt),e(T,I),e(n,pt),e(n,$),l(N,$,null),e($,gt),e($,W),e(n,_t),e(n,O),l(D,O,null),e(O,ht),e(O,V),e(n,ft),e(n,y),l(F,y,null),e(y,xt),e(y,A),b(t,J,d),l(L,t,d),b(t,Y,d),b(t,X,d),Z=!0},p:wt,i(t){Z||(p(q.$$.fragment,t),p(R.$$.fragment,t),p(Q.$$.fragment,t),p(w.$$.fragment,t),p(P.$$.fragment,t),p(C.$$.fragment,t),p(N.$$.fragment,t),p(D.$$.fragment,t),p(F.$$.fragment,t),p(L.$$.fragment,t),Z=!0)},o(t){g(q.$$.fragment,t),g(R.$$.fragment,t),g(Q.$$.fragment,t),g(w.$$.fragment,t),g(P.$$.fragment,t),g(C.$$.fragment,t),g(N.$$.fragment,t),g(D.$$.fragment,t),g(F.$$.fragment,t),g(L.$$.fragment,t),Z=!1},d(t){t&&(o(j),o(G),o(S),o(K),o(B),o(n),o(J),o(Y),o(X)),o(h),_(q,t),_(R,t),_(Q),_(w),_(P),_(C),_(N),_(D),_(F),_(L,t)}}}const Ut='{"title":"Quantization","local":"quantization","sections":[{"title":"ORTQuantizer","local":"optimum.onnxruntime.ORTQuantizer","sections":[],"depth":2}],"depth":1}';function kt(bt){return Pt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Wt extends Ct{constructor(h){super(),Nt(this,h,kt,Lt,Qt,{})}}export{Wt as component};
